package it.unipr.ce.dsg.deus.example.basic;

import java.util.Properties;

import it.unipr.ce.dsg.deus.core.Event;
import it.unipr.ce.dsg.deus.core.InvalidParamsException;
import it.unipr.ce.dsg.deus.core.Process;
import it.unipr.ce.dsg.deus.core.RunException;
import it.unipr.ce.dsg.deus.p2p.node.Peer;

public class DisconnectionEvent extends Event {

	public DisconnectionEvent(String id, Properties params,
			Process parentProcess) throws InvalidParamsException {
		super(id, params, parentProcess);
		initialize();
	}

	public void initialize() throws InvalidParamsException { }

	public Object clone() {
		DisconnectionEvent clone = (DisconnectionEvent) super.clone();
		return clone;
	}
	
	@Override
	public void run() throws RunException {
		Peer peer = (Peer) associatedNode;
		//System.out.println("DISC " + peer);
		for (int i = 0; i < peer.getNeighbors().size(); i++) {
			Peer neighbor = peer.getNeighbors().get(i);
			if (neighbor.getNeighbors().contains(peer)) {
				//System.out.println("DISC " + neighbor + " has k = " + neighbor.getNeighbors().size());
				neighbor.removeNeighbor(peer);
				//System.out.println("DISC " + neighbor + " has k = " + neighbor.getNeighbors().size());
			}
		}
		peer.resetNeighbors();
	    //System.out.println( "Num nodes = " + this.engine.getNodes().size());
		this.engine.removeNode(peer);
	    //System.out.println( "Num nodes = " + this.engine.getNodes().size());

	}

}
