package it.unipr.ce.dsg.deus.example.casperprotocol;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Properties;
import java.util.Random;
import java.util.Properties;

import it.unipr.ce.dsg.deus.core.Event;
import it.unipr.ce.dsg.deus.core.InvalidParamsException;
import it.unipr.ce.dsg.deus.core.Process;
import it.unipr.ce.dsg.deus.core.RunException;
import it.unipr.ce.dsg.deus.p2p.node.Peer;

public class BroadcastProposalEvent extends Event {

	
	
	
	public BroadcastProposalEvent(String id, Properties params, Process parentProcess) throws InvalidParamsException {
		super(id, params, parentProcess);
		//initialize(); non serve, non ho parametri per questo evento
	}
	
//	public void initialize() {
//		if (params.containsKey(STRATEGY))
//			strategy = params.getProperty(STRATEGY);
//	}
	
	

	@Override
	public void run() throws RunException {

		
		//scelgo un nodo a caso
		Random random = this.getEngine().getSimulationRandom(); 
		CasperProtocolPeer peer = (CasperProtocolPeer) this.getEngine().getNodes().get(0);
		
		
		CasperProtocolPeer choosen = (CasperProtocolPeer) peer.getNeighbors().get(random.nextInt(peer.getNeighbors().size()));
		//System.out.println("STAKE: "+choosen.getStake()+" Nodo numero: "+choosen.getKey());
		choosen.setChoosen(true);//é stato scelto quel nodo per proporre un blocco, il suo ultimo blocco
		//System.out.print("Sono il nodo: "+choosen.getKey()+" e sono: "+choosen.isChoosen()+"\n");
		

		for (int j = 0; j < 5; j++) {//per ogni nodo, se le chiavi sono diverse, setto choosen a false per sicurezza.
			CasperProtocolPeer target = (CasperProtocolPeer) this.getEngine().getNodes().get(j);
			if(choosen.getKey() != target.getKey()){
				target.setChoosen(false);
				//System.out.print("Sono il nodo: "+target.getKey()+" e sono: "+target.isChoosen()+"\n");
			}
			else{
				//niente
				//System.out.print("Sono il nodo: "+target.getKey()+" e sono: "+target.isChoosen()+"\n");
			}
		}
		
		//chiamo l'evento VOTE che escluderá dalla votazione il noto con choose=true
		BroadcastVoteEvent newevent = (BroadcastVoteEvent) this.getEngine().createEvent(BroadcastVoteEvent.class, triggeringTime);
		this.getEngine().insertIntoEventsList(newevent);
		
	}

}
